#include <iostream>
#include <string>
using namespace std;
int main(){
    int n; cin>>n;
    int o,a,b,ab;
    int oK[n],aK[n],bK[n],abK[n];
    
    cin>>o>>a>>b>>ab;
    int j = 0;
    bool moguce = true;
    string oznaka[n];
    int brojJedinica[n];
    for(int i = 0; i<n; i++){
        oK[i]= 0;
        aK[i] = 0;
        bK[i] = 0;
        abK[i] = 0;
        cin>>oznaka[i];
        cin>>brojJedinica[i];
        if(oznaka[i] == "O"){
            for(int j = 0; j<o; j++){
                o--;
                brojJedinica[i]--;
                oK[i]++;
            }
            if(brojJedinica[i]>0){
                moguce = false;
            }
        }else if( oznaka[i] == "A"){
            while(j<a && brojJedinica[i]>0){
                a--;
                brojJedinica[i]--;
                aK[i]++;
                j++;
            }
            if(brojJedinica>0){
                while(j<o && brojJedinica[i]>0){
                    o--;
                    brojJedinica[i]--;
                    oK[i]++;
                    j++;
                }  
                if(brojJedinica[i]>0){
                    moguce = false;
                }
            }
            
        }else if( oznaka[i] == "B"){
            while(j<b && brojJedinica[i]>0){
                b--;
                brojJedinica[i]--;
                bK[i]++;
                j++;
            }
            if(brojJedinica[i]>0){
                while(j<o && brojJedinica[i]>0){
                    o--;
                    brojJedinica[i]--;
                    oK[i]++;
                    j++;
                }
                if(brojJedinica[i]>0){
                    moguce = false;
                }
            }
        }else{
            int Preostalo = o+a+b+ab; 
            
            if(Preostalo<brojJedinica[i]){
                moguce = false;
            }else{
                if(brojJedinica[i]>0){
                    while(ab !=0 && brojJedinica[i]>0){
                        ab--;
                        brojJedinica[i]--;
                        abK[i]++;
                        j++;
                    }
                    while(o !=0 && brojJedinica[i]>0){
                        o--;
                        brojJedinica[i]--;
                        oK[i]++;
                        j++;
                    }
                    while(a !=0 && brojJedinica[i]>0){
                        a--;
                        brojJedinica[i]--;
                        aK[i]++;
                        j++;
                    }
                    while(b !=0 && brojJedinica[i]>0){
                        b--;
                        brojJedinica[i]--;
                        bK[i]++;
                        j++;
                    }       

                }    
            }
        }
    }
    cout<<(moguce ? "moguce" : "nemoguce" )<<endl;
    if(moguce){
        for(int i = 0; i<n; i++)
            cout<<oK[i]<<" "<< aK[i]<<" "<<bK[i]<<" "<<abK[i]<<endl;
        
    }
    return 0;
}